/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
var usuario_position = null;

var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicity call 'app.receivedEvent(...);'
    onDeviceReady: function() {
        app.receivedEvent('deviceready');
    },
    // Update DOM on a Received Event
    receivedEvent: function(id) {
        // var parentElement = document.getElementById(id);
        // var listeningElement = parentElement.querySelector('.listening');
        // var receivedElement = parentElement.querySelector('.received');

        // listeningElement.setAttribute('style', 'display:none;');
        // receivedElement.setAttribute('style', 'display:block;');
        // console.log('Received Event: ' + id);
        // alert('deviceready');
        if (id=='deviceready'){
            window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, gotFS, fail);
        }
        // console.log('Received Event: ' + id);
    }
};

$(document).bind('PG_timeout', function(e) {
    load_initial_data();
}, false);
// $(document).ready(function(){
// // //     console.log('ini 1');
// //     load_initial_data();
//             getGeolocation();
// });

var fs;

function gotFS(fileSystem) {
    // console.log('en gotFS');
    fs=fileSystem;
    load_initial_data();
}

function load_initial_data() {
    getCache(
        'update_times.json', 
        function(data){
            update_times = data;
            loaded_times();
        },
        loaded_times 
    );



    // getCache('update_times.json', function(data){
    //     update_times = data;
    // });
    // getCache(
    //     'users_datos.json', 
    //     function(data){
    //         users.datos = data;
    //         redirect_to('users#check_login');
    //     }, 
    //     function(data){
    //         redirect_to('users#check_login');
    //     }
    // );

    // fileSystem.root.getFile("readme.txt", {create: true, exclusive: false}, gotFileEntry, fail);
}

function loaded_times(){
    getCache(
        'users_datos.json', 
        function(data){
            if ($.isEmptyObject(data)){
                redirect_to('users#login');
            } else {
                users.datos = data;
                redirect_to('users#check_login');
            }
        },
        function(data){
            redirect_to('users#login');
        }
    );
}

// function gotFileEntry(fileEntry) {
//     fileEntry.createWriter(gotFileWriter, fail);
// }

// function gotFileWriter(writer) {
//     writer.onwriteend = function(evt) {
//         console.log("contents of file now 'some sample text'");
//         writer.truncate(11);
//         writer.onwriteend = function(evt) {
//             console.log("contents of file now 'some sample'");
//             writer.seek(4);
//             writer.write(" different text");
//             writer.onwriteend = function(evt){
//                 console.log("contents of file now 'some different text'");
//             }
//         };
//     };
//     writer.write("some sample text");
// }

// function fail(error) {
//     console.log(error.code);
// }

function write_to_file(_file, _text, fail_cb){
    try {
        dataDir = fs.root.getDirectory("masymas", {create: true});
        dataDir.getFile(
            _file, 
            {create: true, exclusive: false}, 
            function (fileEntry) {
                fileEntry.createWriter(
                    function (writer) {
                        writer.write(_text);
                    }
                    , fail
                );
            },
            function (error) {
                // console.log('El fichero no existe');
                fail_cb();
            }
        );
    } catch(err) {
        fail_cb();
    }
}

function remove_file(_file, cb, fail_cb) {
    try {        
        dataDir = fs.root.getDirectory("masymas", {create: true});
        dataDir.getFile(
            _file, 
            {create: false}, 
            function(entry) {
                entry.remove(
                    function() {
                        cb();                   
                    }, 
                    fail
                );
            }, 
            fail
        )

        // entry.remove(function() {
        //     navigator.notification.alert(entry.toURI(), null, 'Entry deleted');                    
        // }, fail);
    } catch(err) {
        fail_cb();
    }
}

function fail(error) {
    // console.log(error.code);
}

function read_from_file(_file, cb, fail_cb){
    try{
        dataDir = fs.root.getDirectory("masymas", {create: true});
        dataDir.getFile(
            _file, 
            {create: true, exclusive: false}, 
            function (fileEntry) {
                // fileEntry.file(readAsText, fail);
                fileEntry.file(
                    function (file) {
                        var reader = new FileReader();
                        reader.onloadend = function (evt) {
                            // console.log(cb);
                            cb(evt.target.result);
                        };
                        reader.readAsText(file);
                    }
                    , function(){
                        fail_cb();
                    }
                );
                // fileEntry.file(
                //     function (file) {
                //         console.log('readAsText');
                //         var reader = new FileReader();
                //         reader.onstart = function(evt) {
                //             console.log('starting...');
                //         };
                //         reader.onloadend = function(evt) {
                //             console.log('onloadend');
                //             cb(evt.target.result);
                //         };
                //         reader.onerror = function(){
                //             console.log('error_reading');
                //         };
                //         reader.onload = function(){
                //             console.log('onload');
                //         };
                //         reader.onabort = function(){
                //             console.log('onabort');
                //         };

                //         reader.readAsDataURL(file);
                //         console.log('readAsText end:' + file);
                //     }, 
                //     fail
                // );
            },
            function (error) {
                // console.log('El fichero no existe');
                fail_cb();
            }
            // fail
        );
    } catch(err) {
        fail_cb();
    }
}



var fail = function (error) {
    // alert("<br/>FAIL ");
    // alert("<br/>" + error.code);
    console.log(error.code);
};

    // function readAsText(file) {
    //     var reader = new FileReader();
    //     reader.onloadend = function(evt) {
    //         console.log("Read as text");
    //         console.log(evt);
    //         console.log(evt.target);
    //         console.log(evt.target.result);
    //         console.log("Done");
    //     };
    //     reader.readAsText(file);
    // }

// function check_bg(){
//     if ($("#main-container").length==1) {
//         $('body').addClass('app');
//     } else {
//         $('body').removeClass('app');
//     }
// }

function set_fondo_inner(){
	$("body").css("background-color", "#f7f7f7");
}

function restaura_iconos_footer(){
	$("#footer_icono_tarjeta").attr("src", "img/footer_tarjeta_1.png");
	$("#footer_icono_ofertas").attr("src", "img/footer_ofertas_1.png");
	$("#footer_icono_mensajes").attr("src", "img/footer_mensajes_1.png");
	$("#footer_icono_tiendas").attr("src", "img/footer_tiendas_1.png");
	$("#footer_icono_info").attr("src", "img/footer_info_1.png");
}

function _show_tarjeta(){
	// set_fondo_inner();
	// restaura_iconos_footer();
	// $("#footer_icono_tarjeta").attr("src", "img/footer_tarjeta_2.png");
	// $("#cabecera-titulo").html("Mi Tarjeta");
}

function _show_ofertas(){
	set_fondo_inner();
	restaura_iconos_footer();
	$("#footer_icono_ofertas").attr("src", "img/footer_ofertas_2.png");
	$("#cabecera-titulo").html("Ofertas");
}

function _show_mensajes(){
	set_fondo_inner();
	restaura_iconos_footer();
	$("#footer_icono_mensajes").attr("src", "img/footer_mensajes_2.png");
	$("#cabecera-titulo").html("Mensajes");
}

function _show_tiendas(){
	set_fondo_inner();
	restaura_iconos_footer();
	$("#footer_icono_tiendas").attr("src", "img/footer_tiendas_2.png");
	$("#cabecera-titulo").html("Tiendas");
}

function _show_info(){
	set_fondo_inner	();
	restaura_iconos_footer();
	$("#footer_icono_info").attr("src", "img/footer_info_2.png");
	$("#cabecera-titulo").html("Información");
}


function getGeolocation(){
    // if (navigator.geolocation){
        navigator.geolocation.getCurrentPosition(onPosSuccess, onPosError,{timeout:2000});
        // navigator.geolocation.getCurrentPosition(function(position){console.log(position)}, function(){console.log('error')});
    // } else {
        // initialize_map();
    // }
}

function get_user_position(position){
    pos = position;
	usuario_lat		 = position.coords.latitude;
	usuario_lng 	 = position.coords.longitude;
	usuario_position = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);

}
function onPosSuccess(position) {
    // alert('Latitude: '          + position.coords.latitude          + '\n' +
          // 'Longitude: '         + position.coords.longitude         + '\n' +
          // 'Altitude: '          + position.coords.altitude          + '\n' +
          // 'Accuracy: '          + position.coords.accuracy          + '\n' +
          // 'Altitude Accuracy: ' + position.coords.altitudeAccuracy  + '\n' +
          // 'Heading: '           + position.coords.heading           + '\n' +
          // 'Speed: '             + position.coords.speed             + '\n' +
          // 'Timestamp: '         + position.timestamp                + '\n');
    
    pos = position;
    usuario_lat      = position.coords.latitude;
    usuario_lng      = position.coords.longitude;
    usuario_position = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
    initialize_map();
}
function onPosError(error) {
    // alert('code: '    + error.code    + '\n' +
          // 'message: ' + error.message + '\n');
    initialize_map();
}
// getGeolocation();
function centrar_codigo_barras(){
	// var posicion = $("#img_carcasa_tarjeta").offset().left;
	// console.log("posicion(0) = " + posicion);
	// posicion = posicion + 35;

	// console.log("posicion = " + posicion);
	
	// $("#tarjeta_codigo_barras").css("left", posicion);
}