/**
 * Routing.js v1.0.0
 *
 * Copyright (c) 2013 Vorago
 * Released under the Vorago License
 */


var jqOnFn = jQuery.fn.on; 
$.fn.on = function(event_name, selector, fn) { 
   if (!fn && selector && typeof selector === 'function') { 
      fn = selector; 
      selector = null; 
   } 
   if (fn) { 
      var ofn = fn; 
      var wfn = function() { 
      try { 
        ofn.apply(this, arguments); 
      } 
      catch ( ex ) { 
        throw( "\n\nError JavaScript en un controlador de eventos: \nEvento: " + event_name + "\nSelector CSS: " + selector + "\nError: " + ex ); 
       } 
     }; 
     fn = wfn; 
   } 
   return jqOnFn.call(this, event_name, selector, fn); 
}; 


String.prototype.endsWith = function(suffix) {
    return this.indexOf(suffix, this.length - suffix.length) !== -1;
};

var templates = {};
var loaded_files = [];



var load_template = function(name) {
  var _url = '';
  var found = false;
  
    _url = views_path+name+'.html.eco';
    $.ajax({
        type: "HEAD",
        async: false,
        url: _url,
        success: function(){
          found = true; 
        }
    });
    if (!found){
      _url = views_path+name+'.js';
    }

  if (_url.endsWith('.html.eco')) load_compilers();

  //Cargamos la aplantilla
  jQuery.ajax({
      type: 'GET',
      url: _url,
      async: false,
      dataType: 'html',
      success: function (data, textStatus) {
        var _name = name.replace(/\//g, '__').replace(/\./g, '__').replace(/^\_*/g,'');
        if (_url.endsWith('.html.eco')) {
          try {
            var _res = eco.compile(data, { identifier: _name});
          } catch (err) {
            throw "\n\nError de sintaxis ECO en '" + _url + "'\nError: " + err + ".";
          }
          try {
            window.eval(_res);
          } catch (err) {
            throw "\n\nError de sintaxis JavaScript en '" + _url + "'\nError: " + err + ".";
          }
          // eval('window.' + _name + ' = ' + _name);
        } else {
          try {
            window.eval( _name + " = " + data);
          } catch (err) {
            throw "\n\nError de sintaxis JavaScript en '" + _url + "'\nError: " + err + ".";
          }
        }
      },
      error: function (xhr, err, e) {
          alert("Error: " + err);
      }
  });

  //Cargamos los eventos, si existen
  load_file(events_path+name.replace(/\/.*/,'')+'_events');

};

var load_file = function(name) {
  if (jQuery.inArray(name,loaded_files)==-1){
    loaded_files.push(name);
    var _url = '';
    var found = false;
  
    if (name.endsWith('.js')){
      _url = name;
      found = true; 
    }

    if (!found){
      _url = name+'.coffee';
      $.ajax({
          type: "HEAD",
          async: false,
          url: _url,
          success: function(){
            found = true; 
          }
      });
    }
    if (!found){
      _url = name+'.js';
      $.ajax({
          type: "HEAD",
          async: false,
          url: _url,
          success: function(){
            found = true; 
          }
      });
    }

    if(found){
    
      if (_url.endsWith('.coffee')) load_compilers();
      
      jQuery.ajax({
          type: 'GET',
          url: _url,
          async: false,
          dataType: 'html',
          success: function (data, textStatus) {
            var _name = name.replace(/\//g, '__').replace(/\./g, '__').replace(/^\_*/g,'');
            if (_url.endsWith('.coffee')) {
              try {
                var _res = CoffeeScript.compile(data);
              } catch (err) {
                throw "\n\nError de sintaxis CoffeeScript en '" + _url + "'\nError: " + err + ".";
              }
              try {
                window.eval(_res);
              } catch (err) {
                throw "\n\nError de sintaxis JavaScript en '" + _url + "'\nError: " + err + ".";
              }
            } else {
              try {
                window.eval(data);
              } catch (err) {
                throw "\n\nError de sintaxis JavaScript en '" + _url + "'\nError: " + err + ".";
              }
            }
          },
          error: function (xhr, err, e) {
              alert("Error: " + err);
          }
      });
    }
  }
};

var load_compilers = function(){
  $.ajaxSetup({
    async: false
  });
  if (typeof(coffee_compiler_loaded) == 'undefined') {
    $.getScript("./lib/coffee-script.js", function(data, textStatus, jqxhr) {});
  }
  if (typeof(eco_compiler_loaded) == 'undefined') {
    $.getScript("./lib/eco.js", function(data, textStatus, jqxhr) {});
  }
  $.ajaxSetup({
    async: true
  });
}

var render = function(name, params) {
  var _name = name.replace(/\//g, '__').replace(/\./g, '__').replace(/^\_*/g,'');
  if (window[_name]==undefined) {
    if (templates[_name]==undefined) {
      load_template(name);
    }
  }
  return eval(_name + '(params)');
};

var navigate_to = function(data, params, elto){
  redirect_to(data.linkTo, data, params, elto);
}

var redirect_to = function(path, data, params, elto){
  if (path.indexOf('#')==0){
    var c = path.split('#')[1];
    var a = path.split('#')[2];
  } else {
    var c = path.split('#')[0];
    var a = path.split('#')[1];
    // $('body').attr('data-screen', c + '-' + a);
    $('body').removeClass()
    $('body').addClass('action-' + c + '-' + a);
  }
  if (!window.hasOwnProperty(c)) {
    load_file(controllers_path+c+'_controller');
  }
  try {
    if (params) {
      eval(c+'.'+a+'(data, params, elto)');
    } else {
      eval(c+'.'+a+'(data, elto)');
    }
  } catch (err) {
    throw "\n\nError en el controlador '" + c + "_controller\nAction: " + a + "\nError: " + err + ".";
  }
}

if (typeof(environment) == 'undefined' || environment != 'production') {
    load_file('./config/development.js');
}

window.onload = loaded;

function loaded() {
  window.PhoneGap ? document.addEventListener("deviceready", ready, false) : ready();
}

$(document).on( "PG_timeout", function(  ) {
  ready();
});

function ready() {
  setTimeout(function () {
    initial_bindings();
  }, 200);
}

function initial_bindings() {
  if (typeof(root_path) == 'undefined' || root_path != '') {
  	redirect_to(root_path)
  }

  // Para trabajar con mousup en vez de click
  if (typeof(link_behaviour) == 'undefined' || link_behaviour == 'mouseup') {

    // $(document).delegate("a[data-link-to], button[data-link-to]",'mouseup', function(e){
    //   e.preventDefault();
    //   e.stopPropagation();
    // });
    $(document).delegate("a[data-link-to], button[data-link-to]",'click', function(e){
      e.preventDefault();
      e.stopPropagation();
      navigate_to($(this).data());
    });

  } else {
   
    $(document).delegate("a[data-link-to], button[data-link-to]",'click', function(e){
      e.preventDefault();
      navigate_to($(this).data(), null, $(this));
    });
  
  }

  $(document).delegate("form[data-link-to]", 'submit', function(e){
    e.preventDefault();
    navigate_to($(this).data(), $(this).serializeArray(), $(this));
  });


  // $(document).delegate(".screen", 'animationend webkitTransitionEnd oTransitionEnd', function(e){
  //   $('.screen:not(:last)').remove();
  //   // console.log('dome');
  //   // if (e.originalEvent.animationName=='leave'){
  //   //   e.target.remove();
  //   // }
  //   // console.log(e.originalEvent.animationName);
  // });

  // $(document).delegate(".screen", 'webkitAnimationStart', function(e){
  //   console.log('init');
  // });
//   $(document).delegate("#loading", 'webkitTransitionEnd', function(e){
//     $('.screen:not(:last)').remove();
//     $("#loading").addClass('show2');
// console.log('acabo: ' + $("#loading").css('top'));
//     check_loaded();
//   });
//   $(document).delegate("#loading", 'oTransitionEnd', function(e){
//     $('.screen:not(:last)').remove();
//     $("#loading").addClass('show2');
// console.log('acabo: ' + $("#loading").css('top'));
//     check_loaded();
//   });


  $(document).delegate("#loading", 'oTransitionEnd msTransitionEnd transitionend webkitTransitionEnd transitionEnd', function(e){
    // $('.screen:not(:last)').remove();
    
    if ($("#loading").position().top>=0){
      $("#loading").addClass('show2');
      check_load_end();
    }
    e.stopPropagation();
  });
}

function periodo(from, to){
  if (from.getMonth() == to.getMonth()) {
    return "Del " + from.getDate() + " al " + to.getDate() + " de " + meses[from.getMonth()];
  } else {

    return "Del " + from.getDate() + " de " + meses[from.getMonth()] + " al " + to.getDate() + " de " + meses[to.getMonth()];
  }
}

var meses=["Enero", "Febrero", "Marzo", "Abril", "Mayo", "Junio", "Julio", "Agosto", "Septiembre", "Octubre", "Noviembre", "Diciembre"];
